/*
	*
	* Copyright 2020 Britanicus <marcusbritanicus@gmail.com>
	*
	* This file is a part of DesQ project (https://gitlab.com/desq/)
	*

	*
	* This program is free software; you can redistribute it and/or modify
	* it under the terms of the GNU General Public License as published by
	* the Free Software Foundation; either version 3 of the License, or
	* (at your option) any later version.
	*

	*
	* This program is distributed in the hope that it will be useful,
	* but WITHOUT ANY WARRANTY; without even the implied warranty of
	* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	* GNU General Public License for more details.
	*

	*
	* You should have received a copy of the GNU General Public License
	* along with this program; if not, write to the Free Software
	* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
	* MA 02110-1301, USA.
	*
*/

#pragma once

#include <QtWidgets>
#include <QtGui>
#include <QtCore>
#include <QtDBus>

class DesQSettings;
class TrackedProcess;

class DesQShellManager : public QObject {
	Q_OBJECT;

	public:
		DesQShellManager();
		~DesQShellManager();

        bool isServiceRunning();
		bool isObjectRegistered();

        void startManagement();

    public Q_SLOTS:
        void shutdown();

        void handleHotCorner( int );
		void cancelHotCorner( int );

    private:
        void setupHotCorners();

        bool serviceRunning;
		bool objectRegistered;

        DesQSettings *shellSett;
        QDBusInterface *session;

        TrackedProcess *bg = nullptr;
        TrackedProcess *panel = nullptr;
        TrackedProcess *dock = nullptr;
        TrackedProcess *menu = nullptr;
        TrackedProcess *sni = nullptr;
        TrackedProcess *ss = nullptr;
        TrackedProcess *widgets = nullptr;
};
